## purple-skypeweb 1.5

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

set(PROJECT_NAME "skypeweb" C)
set(VERSION_MAJOR "1")
set(VERSION_MINOR "5")
set(VERSION_PATCH "0")

project(${PROJECT_NAME})

set(CMAKE_MODULE_PATH 
    ${CMAKE_SOURCE_DIR}/cmake 
    ${CMAKE_MODULE_PATH}
    )

find_package(PkgConfig REQUIRED)

pkg_check_modules(GLIB REQUIRED  glib-2.0)
pkg_check_modules(JSON-GLIB REQUIRED json-glib-1.0)
pkg_check_modules(PURPLE REQUIRED purple)

add_definitions(-Wall)

include_directories(
    ${PURPLE_INCLUDE_DIRS}
    ${GLIB2_INCLUDE_DIRS}
    ${JSON-GLIB_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/purple2compat
    )

set(SRC_LIST
    skypeweb_connection.c
    skypeweb_contacts.c
    skypeweb_login.c
    skypeweb_messages.c
    skypeweb_util.c
    libskypeweb.c 
	purple2compat/http.c
	purple2compat/purple-socket.c
    )

add_library(${PROJECT_NAME} SHARED ${SRC_LIST})

target_link_libraries(${PROJECT_NAME}
    ${PURPLE_LIBRARIES}
    ${GLIB2_LIBRARIES}
    ${JSON-GLIB_LIBRARIES}
    )

link_directories(
    ${PURPLE_LIBRARY_DIRS}
    )


#install(TARGETS ${PROJECT_NAME} DESTINATION ${LIB_INSTALL_DIR})
exec_program("${PKG_CONFIG_EXECUTABLE} --variable=plugindir purple 2>/dev/null"
        OUTPUT_VARIABLE LIB_INSTALL_DIR
        RETURN_VALUE PURPLE_PLUGINDIR_RET)

if (NOT PURPLE_PLUGINDIR_RET EQUAL 0)
	message( FATAL_ERROR "${PKG_CONFIG_EXECUTABLE} --variable=plugindir purple -- returned a non-null error code")
endif()

install(TARGETS ${PROJECT_NAME} DESTINATION ${LIB_INSTALL_DIR})

exec_program("${PKG_CONFIG_EXECUTABLE} --variable=datadir purple 2>/dev/null"
        OUTPUT_VARIABLE PURPLE_DATADIR
        RETURN_VALUE PURPLE_DATADIR_RET)

if (NOT PURPLE_DATADIR_RET EQUAL 0)
	message( FATAL_ERROR "${PKG_CONFIG_EXECUTABLE} --variable=datadir purple -- returned a non-null error code")
endif()

install(DIRECTORY "icons/"
    DESTINATION "${PURPLE_DATADIR}/pixmaps/pidgin/protocols/"
    )

install(FILES "theme"
    DESTINATION "${PURPLE_DATADIR}/pixmaps/pidgin/emotes/skype/"
    )

# package settings
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Skype protocol plug-in for libpurple")
set(CPACK_PACKAGE_VENDOR "Eion Robb")
set(CPACK_PACKAGE_DESCRIPTION "libskypeweb is a Skype protocol plug-in for libpurple based on the Skype Web client")
set(CPACK_PACKAGE_CONTACT "edhelas@movim.eu")
set(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON) 
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${VERSION}")
set(ACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${VERSION}")
SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libpurple0 (>= 2.10.0), libglib2.0-0 (>= 2.24), libjson-glib-1.0-0 (>= 0.8.0)")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Jaussoin Timothée") #required

set(PACK "DEB" CACHE STRING "Generate a Package")
set(CPACK_GENERATOR ${PACK})

include(CPack)

=== Makefile ===

PIDGIN_TREE_TOP ?= ../../pidgin-2.10.11
PIDGIN3_TREE_TOP ?= ../../pidgin-main
LIBPURPLE_DIR ?= $(PIDGIN_TREE_TOP)/libpurple
WIN32_DEV_TOP ?= $(PIDGIN_TREE_TOP)/../win32-dev

WIN32_CC ?= $(WIN32_DEV_TOP)/mingw-4.7.2/bin/gcc

PKG_CONFIG ?= pkg-config
DIR_PERM = 0755
LIB_PERM = 0755
FILE_PERM = 0644
MAKENSIS ?= makensis

CFLAGS	?= -O2 -g -pipe
LDFLAGS ?= 

# Do some nasty OS and purple version detection
ifeq ($(OS),Windows_NT)
  SKYPEWEB_TARGET = libskypeweb.dll
  SKYPEWEB_DEST = "$(PROGRAMFILES)/Pidgin/plugins"
  SKYPEWEB_ICONS_DEST = "$(PROGRAMFILES)/Pidgin/pixmaps/pidgin/protocols"
  SKYPEWEB_THEME_DEST = "$(PROGRAMFILES)/Pidgin/pixmaps/pidgin/emotes/skype"
  MAKENSIS = "$(PROGRAMFILES)/NSIS/makensis.exe"
else

  UNAME_S := $(shell uname -s)

  #.. There are special flags we need for OSX
  ifeq ($(UNAME_S), Darwin)
    #
    #.. /opt/local/include and subdirs are included here to ensure this compiles
    #   for folks using Macports.  I believe Homebrew uses /usr/local/include
    #   so things should "just work".  You *must* make sure your packages are
    #   all up to date or you will most likely get compilation errors.
    #
    INCLUDES = -I/opt/local/include -lz $(OS)

    CC = gcc
  else
    INCLUDES = 
    CC ?= gcc
  endif

  ifeq ($(shell $(PKG_CONFIG) --exists purple-3 2>/dev/null && echo "true"),)
    ifeq ($(shell $(PKG_CONFIG) --exists purple 2>/dev/null && echo "true"),)
      SKYPEWEB_TARGET = FAILNOPURPLE
      SKYPEWEB_DEST =
	  SKYPEWEB_ICONS_DEST =
	  SKYPEWEB_THEME_DEST =
    else
      SKYPEWEB_TARGET = libskypeweb.so
      SKYPEWEB_DEST = $(DESTDIR)`$(PKG_CONFIG) --variable=plugindir purple`
	  SKYPEWEB_ICONS_DEST = $(DESTDIR)`$(PKG_CONFIG) --variable=datadir purple`/pixmaps/pidgin/protocols
	  SKYPEWEB_THEME_DEST = $(DESTDIR)`$(PKG_CONFIG) --variable=datadir purple`/pixmaps/pidgin/emotes/skype
    endif
  else
    SKYPEWEB_TARGET = libskypeweb3.so
    SKYPEWEB_DEST = $(DESTDIR)`$(PKG_CONFIG) --variable=plugindir purple-3`
	SKYPEWEB_ICONS_DEST = $(DESTDIR)`$(PKG_CONFIG) --variable=datadir purple-3`/pixmaps/pidgin/protocols
	SKYPEWEB_THEME_DEST = $(DESTDIR)`$(PKG_CONFIG) --variable=datadir purple-3`/pixmaps/pidgin/emotes/skype
  endif
endif

WIN32_CFLAGS = -I$(WIN32_DEV_TOP)/glib-2.28.8/include -I$(WIN32_DEV_TOP)/glib-2.28.8/include/glib-2.0 -I$(WIN32_DEV_TOP)/glib-2.28.8/lib/glib-2.0/include -I$(WIN32_DEV_TOP)/json-glib-0.14/include/json-glib-1.0 -DENABLE_NLS -DPACKAGE_VERSION='"$(PLUGIN_VERSION)"' -Wall -Wextra -Werror -Wno-deprecated-declarations -Wno-unused-parameter -fno-strict-aliasing -Wformat -Wno-sign-compare
WIN32_LDFLAGS = -L$(WIN32_DEV_TOP)/glib-2.28.8/lib -L$(PROTOBUF_C_DIR)/bin -L$(WIN32_DEV_TOP)/json-glib-0.14/lib -lpurple -lintl -lglib-2.0 -lgobject-2.0 -ljson-glib-1.0 -g -ggdb -static-libgcc -lz
WIN32_PIDGIN2_CFLAGS = -I$(PIDGIN_TREE_TOP)/libpurple -I$(PIDGIN_TREE_TOP) $(WIN32_CFLAGS)
WIN32_PIDGIN3_CFLAGS = -I$(PIDGIN3_TREE_TOP)/libpurple -I$(PIDGIN3_TREE_TOP) -I$(WIN32_DEV_TOP)/gplugin-dev/gplugin $(WIN32_CFLAGS)
WIN32_PIDGIN2_LDFLAGS = -L$(PIDGIN_TREE_TOP)/libpurple $(WIN32_LDFLAGS)
WIN32_PIDGIN3_LDFLAGS = -L$(PIDGIN3_TREE_TOP)/libpurple -L$(WIN32_DEV_TOP)/gplugin-dev/gplugin $(WIN32_LDFLAGS) -lgplugin

C_FILES = \
	skypeweb_connection.c \
	skypeweb_contacts.c \
	skypeweb_login.c \
	skypeweb_messages.c \
	skypeweb_util.c \
	libskypeweb.c 
PURPLE_COMPAT_FILES := purple2compat/http.c purple2compat/purple-socket.c
PURPLE_C_FILES := libskypeweb.c $(C_FILES)



.PHONY:	all install FAILNOPURPLE clean

all: $(SKYPEWEB_TARGET)

libskypeweb.so: $(PURPLE_C_FILES) $(PURPLE_COMPAT_FILES)
	$(CC) -fPIC $(CFLAGS) -shared -o $@ $^ $(LDFLAGS) $(PROTOBUF_OPTS) `$(PKG_CONFIG) purple glib-2.0 json-glib-1.0 zlib --libs --cflags`  $(INCLUDES) -Ipurple2compat -g -ggdb

libskypeweb3.so: $(PURPLE_C_FILES)
	$(CC) -fPIC $(CFLAGS) -shared -o $@ $^ $(LDFLAGS) $(PROTOBUF_OPTS) `$(PKG_CONFIG) purple-3 glib-2.0 json-glib-1.0 zlib --libs --cflags` $(INCLUDES)  -g -ggdb

libskypeweb.dll: $(PURPLE_C_FILES) $(PURPLE_COMPAT_FILES)
	$(WIN32_CC) -shared -o $@ $^ $(WIN32_PIDGIN2_CFLAGS) $(WIN32_PIDGIN2_LDFLAGS) -Ipurple2compat

libskypeweb3.dll: $(PURPLE_C_FILES)
	$(WIN32_CC) -shared -o $@ $^ $(WIN32_PIDGIN3_CFLAGS) $(WIN32_PIDGIN3_LDFLAGS)

install: $(SKYPEWEB_TARGET) install-icons install-theme
	mkdir -m $(DIR_PERM) -p $(SKYPEWEB_DEST)
	install -m $(LIB_PERM) -p $(SKYPEWEB_TARGET) $(SKYPEWEB_DEST)

install-icons: icons/16/skype.png icons/22/skype.png icons/48/skype.png icons/16/skypeout.png icons/22/skypeout.png icons/48/skypeout.png
	mkdir -m $(DIR_PERM) -p $(SKYPEWEB_ICONS_DEST)/16
	mkdir -m $(DIR_PERM) -p $(SKYPEWEB_ICONS_DEST)/22
	mkdir -m $(DIR_PERM) -p $(SKYPEWEB_ICONS_DEST)/48
	install -m $(FILE_PERM) -p icons/16/skype.png $(SKYPEWEB_ICONS_DEST)/16/skype.png
	install -m $(FILE_PERM) -p icons/22/skype.png $(SKYPEWEB_ICONS_DEST)/22/skype.png
	install -m $(FILE_PERM) -p icons/48/skype.png $(SKYPEWEB_ICONS_DEST)/48/skype.png
	install -m $(FILE_PERM) -p icons/16/skypeout.png $(SKYPEWEB_ICONS_DEST)/16/skypeout.png
	install -m $(FILE_PERM) -p icons/22/skypeout.png $(SKYPEWEB_ICONS_DEST)/22/skypeout.png
	install -m $(FILE_PERM) -p icons/48/skypeout.png $(SKYPEWEB_ICONS_DEST)/48/skypeout.png

installer: pidgin-skypeweb.nsi libskypeweb.dll
	$(MAKENSIS) "/DPIDGIN_VARIANT"="Pidgin" "/DPRODUCT_NAME"="pidgin-skypeweb" "/DINSTALLER_NAME"="pidgin-skypeweb-installer" "/DJSON_GLIB_DLL"="libjson-glib-1.0.dll" pidgin-skypeweb.nsi

install-theme: theme
	mkdir -m $(DIR_PERM) -p $(SKYPEWEB_THEME_DEST)
	install -m $(FILE_PERM) -p theme $(SKYPEWEB_THEME_DEST)/theme

FAILNOPURPLE:
	echo "You need libpurple development headers installed to be able to compile this plugin"

clean:
	rm -f $(SKYPEWEB_TARGET)

=== debian/changelog ===
purple-skypeweb (1.5-0.1~mx15+1) mx; urgency=medium

  * New upstream release; build for MX 15.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 03 Feb 2019 14:42:42 -0800

purple-skypeweb (1.4.0+git20180215-1~webupd8~xenial0) xenial; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Mon, 12 Mar 2018 12:53:14 +0200

purple-skypeweb (1.4.0+git20170824-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Thu, 24 Aug 2017 13:40:22 +0200

purple-skypeweb (1.4.0+git20170806-1~webupd8~zesty0) zesty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Mon, 07 Aug 2017 12:50:39 +0200

purple-skypeweb (1.4.0+git20170724-1~webupd8~zesty0) zesty; urgency=medium

  * New git pull
  * Bump version

 -- Alin Andrei <andrew@webupd8.org>  Wed, 02 Aug 2017 12:44:19 +0200

purple-skypeweb (1.4.0+git20170623-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull
  * Bump version

 -- Alin Andrei <andrew@webupd8.org>  Fri, 23 Jun 2017 14:41:29 +0200

purple-skypeweb (1.4.0+git20170619-1~webupd8~zesty0) zesty; urgency=medium

  * New git pull
  * Bump version

 -- Alin Andrei <andrew@webupd8.org>  Mon, 19 Jun 2017 12:53:39 +0200

purple-skypeweb (1.4.0+git20170502-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull
  * Bump version

 -- Alin Andrei <andrew@webupd8.org>  Tue, 02 May 2017 11:43:14 +0200

purple-skypeweb (1.3.0+git20170421-1~webupd8~zesty0) zesty; urgency=medium

  * New git pull

 -- Alin Andrei <webupd8@gmail.com>  Mon, 24 Apr 2017 13:06:23 +0200

purple-skypeweb (1.3.0+git20170419-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Wed, 19 Apr 2017 12:56:48 +0200

purple-skypeweb (1.3.0+git20170418-1~webupd8~zesty0) zesty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Tue, 18 Apr 2017 13:11:21 +0200

purple-skypeweb (1.3.0+git20170414-1~webupd8~trusty0) trusty; urgency=medium

  * Bump version
  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Wed, 12 Apr 2017 12:46:32 +0200

purple-skypeweb (1.2.2+git20170330-1~webupd8~zesty0) zesty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Thu, 30 Mar 2017 12:41:29 +0200

purple-skypeweb (1.2.2+git20170328-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Tue, 28 Mar 2017 12:14:39 +0200

purple-skypeweb (1.2.2+git20170317-1~webupd8~zesty0) zesty; urgency=medium

  * Upload for Zesty

 -- Alin Andrei <andrew@webupd8.org>  Mon, 20 Mar 2017 16:10:44 +0200

purple-skypeweb (1.2.2+git20170317-1~webupd8~yakkety0) yakkety; urgency=medium

  * New git pull
  * Fix installing theme file

 -- Alin Andrei <andrew@webupd8.org>  Fri, 17 Mar 2017 11:02:14 +0200

purple-skypeweb (1.2.2+git20170227-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Mon, 27 Feb 2017 11:25:54 +0200

purple-skypeweb (1.2.2+git20161215-1~webupd8~yakkety0) yakkety; urgency=medium

  * New git pull

 -- Alin Andrei <webupd8@gmail.com>  Thu, 15 Dec 2016 11:54:13 +0200

purple-skypeweb (1.2.2+git20161122-1~webupd8~yakkety0) yakkety; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Tue, 22 Nov 2016 12:57:15 +0200

purple-skypeweb (1.2.2+git20161026-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Wed, 26 Oct 2016 14:34:21 +0200

purple-skypeweb (1.2.2+git20161019-1~webupd8~yakkety0) yakkety; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Wed, 19 Oct 2016 12:11:32 +0200

purple-skypeweb (1.2.2+git20161017-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull
  * Bump version

 -- Alin Andrei <andrew@webupd8.org>  Mon, 17 Oct 2016 13:17:23 +0200

purple-skypeweb (1.2.1+git20161013-1~webupd8~yakkety0) yakkety; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Thu, 13 Oct 2016 14:54:19 +0200

purple-skypeweb (1.2.1+git20160810-1~webupd8~trusty0) trusty; urgency=medium

  * New git pull
  * Bump version

 -- Alin Andrei <andrew@webupd8.org>  Wed, 10 Aug 2016 13:38:20 +0200

purple-skypeweb (1.2+git20160721-1~webupd8~xenial0) xenial; urgency=medium

  * New git pull

 -- Alin Andrei <andrew@webupd8.org>  Thu, 21 Jul 2016 13:20:54 +0200

purple-skypeweb (1.2+git20160718-1~webupd8~trusty0) trusty; urgency=medium

  * Initial debianization

 -- Alin Andrei <andrew@webupd8.org>  Mon, 18 Jul 2016 12:20:17 +0200

=== debian/control ===
Source: purple-skypeweb
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Alin Andrei <andrew@webupd8.org>
Section: misc
Priority: optional
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9),
               libglib2.0-dev,
               libjson-glib-dev,
               libpurple-dev
Homepage: https://bitbucket.org/EionRobb/purple-hangouts

Package: purple-skypeweb
Architecture: any
Section: misc
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pidgin-skypeweb
Description: SkypeWeb Plugin for Pidgin
 Adds a "Skype (HTTP)" protocol to the accounts list of Pidgin, 
 Adium, Finch and other libpurple based messengers.

Package: pidgin-skypeweb
Architecture: all
Section: misc
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, purple-skypeweb
Replaces: pidgin-skype
Description: Hangouts icons for Pidgin
 Adds pixmaps for the Skype protocol implemented by 
 the purple-skypeweb package.
